// Header File
// Created 08/06/2006; 10:39:16

#ifndef __FROMPIC__
#define __FROMPIC__

#include <math.h>				// for 'abs'
#include <sprites.h>		// for 'SPRT_OR'

#define SPRT_RPLC			2

// Important !
// Be careful not to use these functions out of your screen: there is no clipping !
// Parameter 'width': width of your original picture in BYTES
// Parameter 'height': height of your original picture in PIXELS
// Parameter 'dest': its width is supposed to be 30 bytes long (no checking is done ! so be careful with virtual screens)
// For 'FromPic_Sprite8', 'FromPic_Sprite16', 'FromPic_Sprite32', 'FromPic_DrawLineFast' and 'FromPic_Dissolve',
// only one drawing mode: RPLC (replace) 


// B&W versions

void FromPic_Sprite8(short x, short y, short h, const unsigned char * sprite, void * src, void * dest, short width);
void FromPic_Sprite16(short x, short y, short h, const unsigned short * sprite, void * src, void * dest, short width);
void FromPic_Sprite32(short x, short y, short h, const unsigned long * sprite, void * src, void * dest, short width);

void FromPic_DrawLineFast(short x1, short y1, short x2, short y2,  void * src, void * dest, short width);
void FromPic_DrawHLineFast_OR(short x1, short x2, short y, void * src, void * dest, short width);
void FromPic_DrawHLineFast_RPLC(short x1, short x2, short y, void * src, void * dest, short width);
void FromPic_Dissolve(void * src, void * dest, short width, short height);

void FromPic_Disk(short radius, short x_center, short y_center, void * src, void * dest, short mode, short width);


// Gray versions

#define FromPic_GraySprite8(x, y, h, sprite_0, sprite_1, src_0, src_1, dest_0, dest_1, width) \
				FromPic_Sprite8(x, y, h, sprite_0, src_0, dest_0, width);	\
				FromPic_Sprite8(x, y, h, sprite_1, src_1, dest_1, width);	\

#define FromPic_GraySprite16(x, y, h, sprite_0, sprite_1, src_0, src_1, dest_0, dest_1, width) \
				FromPic_Sprite16(x, y, h, sprite_0, src_0, dest_0, width);	\
				FromPic_Sprite16(x, y, h, sprite_1, src_1, dest_1, width);	\

#define FromPic_GraySprite32(x, y, h, sprite_0, sprite_1, src_0, src_1, dest_0, dest_1, width) \
				FromPic_Sprite32(x, y, h, sprite_0, src_0, dest_0, width);	\
				FromPic_Sprite32(x, y, h, sprite_1, src_1, dest_1, width);	\


#define FromPic_GrayDrawLineFast(x1, y1, x2, y2, src_0, src_1, dest_0, dest_1, width) \
				FromPic_DrawLineFast(x1, y1, x2, y2, src_0, dest_0, width);	\
				FromPic_DrawLineFast(x1, y1, x2, y2, src_1, dest_1, width);	\

#define FromPic_GrayDrawHLineFast_OR(x1, x2, y, src_0, src_1, dest_0, dest_1, width) \
				FromPic_DrawHLineFast_OR(x1, x2, y, src_0, dest_0, width);	\
				FromPic_DrawHLineFast_OR(x1, x2, y, src_1, dest_1, width);	\

#define FromPic_GrayDrawHLineFast_RPLC(x1, x2, y, src_0, src_1, dest_0, dest_1, width) \
				FromPic_DrawHLineFast_RPLC(x1, x2, y, src_0, dest_0, width);	\
				FromPic_DrawHLineFast_RPLC(x1, x2, y, src_1, dest_1, width);	\

void FromPic_GrayDissolve(void * src_0, void * src_1, void * dest_0, void * dest_1, short width, short height);


#define FromPic_GrayDisk(radius, x_center, y_center, src_0, src_1, dest_0, dest_1, mode, width) \
				FromPic_Disk(radius, x_center, y_center, src_0, dest_0, mode, width);	\
				FromPic_Disk(radius, x_center, y_center, src_1, dest_1, mode, width);	\


#endif